<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { NextStepAlt } from '~/components/common/index.vue';
import {
  PressHero,
  PressKitNav,
  PressKitSection,
} from '~/components/press/index.vue';
import {
  PressKitData,
  pressKitHelper,
} from '~/services/press/press-kit.service';

export default {
  name: 'PresKit',
  components: {
    NextStepAlt,
    PressKitSection,
    PressHero,
    PressKitNav,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: PressKitData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 10,
        'fields.slug': 'press/press-kit',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return pressKitHelper(entryFields);
      })
      .catch((e) => {
        throw new Error('Error when generating page: ', e);
      });
    return { content };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata((this as any).content, this.$route.path),
    };
  },
};
</script>
<template>
  <div>
    <PressHero :data="content?.hero" />
    <div class="press-kit-container">
      <PressKitNav :data="content?.navigation" />
      <PressKitSection
        v-for="section in content?.sections"
        :key="section.id"
        :data="section"
      />
    </div>
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.press-kit-container {
  background: #f9f9f9;
  padding-bottom: $spacing-160;
}
</style>
